var Navigator={};
var storageAngle = 5;//5 degrees Angle ignore, and fire click event to sector

//Calc turn Angle 
Navigator.calcAngle=function(x,y,width,height){
	var AngleRadians=Math.atan2(y - width/2,x - height/2);
	if(AngleRadians<0){
		AngleRadians+= 2 * Math.PI;
	}
	return AngleRadians * 180 / Math.PI;		
};
//Calc section 
Navigator.calcSectorInd=function(rotateAngle){
	var rotateAngle= Math.floor((rotateAngle+60)/120)*120;
	rotateAngle=Navigator.calcAbsAngle(rotateAngle);
				
	var sectorInd=Math.abs((rotateAngle < 0 ? 360 + rotateAngle : rotateAngle)/120);
	
	return {sectorInd:sectorInd,rotateAngle:rotateAngle};		
};

Navigator.calcAbsAngle=function(Angle){
	if(Angle>=360)
		Angle=Angle-360;
	else if(Angle<=-360)
		Angle=Angle+360;
	return Angle;		
};

Navigator.calcTouchedSectorInd=function(rotateAngle,imageRotateAngle){
	rotateAngle= Math.floor((rotateAngle+30 - imageRotateAngle)/120)*120;
	rotateAngle=Navigator.calcAbsAngle(rotateAngle);
				
	var sectorInd=Math.abs(-2 + Math.abs((rotateAngle < 0 ? 360 + rotateAngle : rotateAngle)/120));
			
	return sectorInd;		
};

Navigator.IsInsideCircle=function(x0,y0,x1,y1,r){			
	return Math.pow(x0-x1,2) + Math.pow(y0-y1,2) < Math.pow(r,2);		
};

//alert(cf.getTestCode(1));
Navigator.GetNavControl= function(useBorders, labelEnabled){
	labelEnabledCheked = labelEnabled !== undefined ? labelEnabled : true;
 	
 	var initialImage=Ti.Filesystem.resourcesDirectory + "/Nav1.png";
	var images=["/Nav1.png", "/Nav3.png","/Nav2.png"];
	var imageBlob=Ti.Filesystem.getFile(initialImage).read();

	var platformHeight = Ti.Platform.displayCaps.platformHeight;
	var platformWidth = Ti.Platform.displayCaps.platformWidth;
	if(imageBlob.width > platformWidth || imageBlob.height > platformHeight){
		var min = platformWidth < platformHeight ? platformWidth : platformHeight;
		min *= 0.75;
		imageBlob = {width : min, height : min};
		delete min;
	}
	var mainImageView=Ti.UI.createImageView({
		image:images[0],
		touchEnabled:false,
		rotateAngle:0,
		lastRotateAngle:0,
		width:imageBlob.width,
		height:imageBlob.height		
	});
		
	var mainImageViewContainer=Ti.UI.createView({
		width:imageBlob.width+250,
		height:imageBlob.height+250,
	});
	mainImageViewContainer.add(mainImageView);
	
	//return mainImageView;
	
	if( useBorders){
		mainImageView.borderColor= "red";
		mainImageView.borderWidth = 1;
	}

	if( useBorders){
		mainImageViewContainer.borderColor= "black";
		mainImageViewContainer.borderWidth = 1;
	}
	

	//labels container------------------------
	var labelsContainer=Ti.UI.createView({
		width: imageBlob.width + 200,
		height: imageBlob.width + 200,
		touchEnabled:false,
		rotateAngle:0,
		lastRotateAngle:0		
	});
	if(useBorders){
		labelsContainer.borderWidth = 1;
		labelsContainer.borderColor = "black";
	}
	mainImageViewContainer.add(labelsContainer);
	mainImageViewContainer.add(mainImageView);

	mainImageViewContainer.addEventListener("touchstart",function(e){
		Ti.API.log("EVENT: touchstart");
		if(mainImageViewContainer.animationStarted)
			return;
		Ti.API.info("e.x:"+e.x + " e.y:"+e.y);
		var Angle=Navigator.calcAngle(e.x,e.y,mainImageViewContainer.width,mainImageViewContainer.height);		
		mainImageViewContainer.innerCircleAnimationStarted=true;	
					
		if(Navigator.IsInsideCircle(e.x,e.y,mainImageViewContainer.width/2,mainImageViewContainer.width/2,imageBlob.width/2)){
			//Ti.API.log("touchstart: x=" + e.x + ", y=" + e.y + ",Angle=" + Angle  + ", width=" + imageBlob.width + ", height=" + imageBlob.height);
			if(!mainImageView.touchStartAngle)
		    	mainImageView.touchStartAngle=Angle;

			mainImageViewContainer.clickCancel = false;
		}
	});
	
	mainImageViewContainer.addEventListener("touchmove",function(e){
		if(mainImageViewContainer.animationStarted)
			return;
		if(mainImageViewContainer.lastPos){
			var posDiff=Math.abs(mainImageViewContainer.lastPos.x-e.x) + Math.abs(mainImageViewContainer.lastPos.y-e.y);
			if(mainImageViewContainer.innerCircleAnimationStarted && posDiff < 10)
				return;
		}
		mainImageViewContainer.lastPos={x: e.x, y: e.y};
		var newAngle=Navigator.calcAngle(e.x,e.y,mainImageViewContainer.width,mainImageViewContainer.height);
		//inner circle animation
		if(mainImageViewContainer.innerCircleAnimationStarted){			
		//	Ti.API.log("touchStartAngle=" + mainImageView.touchStartAngle + ",newAngle=" + newAngle);
			var AngleChange=newAngle-mainImageView.touchStartAngle;
		//	Ti.API.log("storageAngle=" + storageAngle + ", AngleChange=" + AngleChange);
			if(Math.abs(AngleChange) > storageAngle){
				mainImageViewContainer.clickCancel = true;
			}	
			else
				return;	
				
			var rotateAngle=mainImageView.rotateAngle + AngleChange;
			rotateAngle=Navigator.calcAbsAngle(rotateAngle);

			var res=Navigator.calcSectorInd(rotateAngle);
			var sectorInd=res.sectorInd;
		//	Ti.API.info("rotate Angle:"+rotateAngle);
			if(mainImageView.image!=images[sectorInd]){
				mainImageView.image=images[sectorInd];
				mainImageViewContainer.fireEvent("sectorSelecting",{index:sectorInd});
			}			
			mainImageView.transform=Ti.UI.create2DMatrix({
				rotate:rotateAngle
			});	
							
			mainImageView.lastRotateAngle=rotateAngle;
			mainImageView.lastAngleChange=AngleChange;
			//Ti.API.log("touchmove: x=" + e.x + ", y=" + e.y + ",rotate=" + rotateAngle);				
		}
	});
	
	mainImageViewContainer.touchEnd = function(e){	
		Ti.API.log("EVENT: touchend");	
		if(mainImageViewContainer.innerCircleAnimationStarted){
			var res=Navigator.calcSectorInd(mainImageView.lastRotateAngle);
			var rotateAngle=res.rotateAngle;
			var sectorInd;
			mainImageView.touchStartAngle = null;
			if(!mainImageView.lastRotateAngle){
				//section touched
				var Angle=Navigator.calcAngle(e.x,e.y,mainImageViewContainer.width,mainImageViewContainer.height);
				sectorInd=Navigator.calcTouchedSectorInd(Angle,mainImageView.rotateAngle);
				rotateAngle=sectorInd * 120;				
			}
			else{
				sectorInd=res.sectorInd;
			}
			
			if(!mainImageViewContainer.clickCancel && !e.cancel){
				var Angle=Navigator.calcAngle(e.x,e.y,mainImageViewContainer.width,mainImageViewContainer.height);
				sectorInd=Navigator.calcTouchedSectorInd(Angle,mainImageView.rotateAngle);
				rotateAngle=sectorInd * 120;		
				mainImageViewContainer.fireEvent("sectorClick",{index:sectorInd});
				Ti.API.log("touchend: x=" + e.x + ", y=" + e.y + ",rotate=" + rotateAngle + " Angle:"+Angle + " sectorInd:"+sectorInd);
				//Ti.API.info("sector Click");

			}			
			mainImageViewContainer.fireEvent("sectorSelected",{index:sectorInd});
			mainImageViewContainer.animationStarted=true;
			mainImageView.image=images[sectorInd];

			//Ti.API.info("mainImageView.lastRotateAngle:"+mainImageView.lastRotateAngle+" rotateAngle:"+rotateAngle);
			if(rotateAngle == 0 && Math.abs(mainImageView.lastRotateAngle) > 180){
				if(mainImageView.lastRotateAngle > 0)
					rotateAngle = 360;
				else
					rotateAngle = -360;
			}
				
			//Ti.API.info("corrected rotateAngle:"+rotateAngle);

			var transform=Ti.UI.create2DMatrix().rotate(mainImageView.lastRotateAngle,rotateAngle);
			mainImageView.animate({transform: transform, duration: 300},function(){
				mainImageView.rotateAngle=rotateAngle;
				mainImageViewContainer.animationStarted=false;
				mainImageView.lastRotateAngle = rotateAngle;
			});							
			

		}
		else{
			labelsContainer.rotateAngle=labelsContainer.lastRotateAngle;
		}			
		mainImageViewContainer.innerCircleAnimationStarted=false;
		mainImageViewContainer.outerCircleAnimationStarted=false;
	};
	
	mainImageViewContainer.addEventListener("twofingertap", function(e){mainImageViewContainer.touchEnd(e);});	
	
	mainImageViewContainer.addEventListener("touchcancel", function(e){mainImageViewContainer.touchEnd(e);});		
	mainImageViewContainer.addEventListener("touchend", function(e){mainImageViewContainer.touchEnd(e);});	
	

	return mainImageViewContainer;	
};
